﻿
using System;
using System.Text;
using System.IO;
using iTextSharp.text;
using iTextSharp.text.pdf;

namespace StampPDF3 {
    class Program {
        static int Main(string[] args) {
            int errorarea = 0;
            try {
                bool sizereturnmode = false;
                bool clearmode = false;
                bool rotated = false;
                bool rrotated = false;
                bool center = false;
                bool allpagemode = false;
                bool rbmode = false;
                bool rbtmode = false;
                bool brgbmode = false;

                string outputfilename;
                string inputfilename;
                string[] stampfilenames;
                string[] sxpoints;
                string[] sypoints;
                string[] txpoints;
                string[] typoints;
                string[] rgbs = { "255", "0", "0" };
                string[] brgbs = { "", "", "" };
                string[] texts;
                string fontname;
                string[] fontsizes={"24"};
                string fontsize;
                string trans;
                string opacity;
                bool copyneeded;    // When the outputfile is not given, make a temporary outputfile. After making, copy a temporary outputfile to inputfile.
                int i;              // Simple Counter
                float ftrans;
                float fopacity = 0f;
                float fscale;
                float fwidth;
                int minlen;
                int lastpage;
                bool dpimode;

                Microsoft.VisualBasic.FileIO.TextFieldParser tfp;


                stampfilenames = null;
                sxpoints = null;
                sypoints = null;
                txpoints = null;
                typoints = null;

                texts = null;
                fontname = "msgothic.ttc";
                
                fscale = 1.0F;
                fwidth = 2.0F;

                inputfilename = "";
                outputfilename = "";
                trans = "";
                opacity = "";

                if (args.Length == 0 || args[0].Contains("/?")) {
                    Console.WriteLine("/o= /i= /s= /sx= /sy= /t= /tx= /ty= /fs= /fn= /tr= /rgb= /sc= ");
                    Console.WriteLine("/o=出力ファイル名。指定のない場合は入力ファイルを上書き。");
                    Console.WriteLine("/i=入力ファイル名");
                    Console.WriteLine("/s=スタンプファイル名１,スタンプファイル名２・・・");
                    Console.WriteLine("/sx=スタンプ１のX座標、スタンプ２のX座標・・・");
                    Console.WriteLine("/sy=スタンプ１のY座標、スタンプ２のY座標・・・");
                    Console.WriteLine("/t=出力文字列１,出力文字列２・・・");
                    Console.WriteLine("/tx=文字列１のX座標、文字列２のX座標・・・");
                    Console.WriteLine("/ty=文字列１のY座標、文字列２のY座標・・・");
                    Console.WriteLine("/fs=フォントサイズ 24");
                    Console.WriteLine("/fn=フォント名 msgothic.ttc");
                    Console.WriteLine("/tr=透過度 0.7");
                    Console.WriteLine("/op=スタンプ不透明度");
                    Console.WriteLine("/rgb=文字列１R,G,B、文字列２のR,G,B・・・");
                    Console.WriteLine("/brgb=文字列１背景色R,G,B、文字列２背景色のR,G,B・・・");
                    Console.WriteLine("/sc=スケール 0.8");
                    Console.WriteLine("/width=与えられた幅で均等に文字列を打つ 2");
                    Console.WriteLine("/xy 押印せずPDFの幅と高さを返すモード");
                    Console.WriteLine("/center 文字をセンタリングするモード");
                    Console.WriteLine("/clear 指定されたエリア((sx,sy)-(tx,ty))のクリア。複数指定可能");
                    Console.WriteLine("/all すべてのページに同じ処理をするモード");
                    Console.WriteLine("/rotated 与えられたPDFは右に90度回転していることを示す");
                    Console.WriteLine("/rrotated 与えられたPDFは左に90度回転していることを示す。rotatedより優先");
                    Console.WriteLine("/rb 右下からの距離指定モード。/sオプション指定時に有効");
                    Console.WriteLine("/rbt 右下からの距離指定モード。/tオプション指定時に有効");
                    Console.WriteLine("Hit Any Key");

                    Console.ReadKey();

                    return -1;
                }

                for (i = 0; i < args.Length; i++) {
                    if (args[i].Contains("/all"))
                        allpagemode = true;
                    if (args[i].Contains("/rb"))
                        rbmode = true;
                    if (args[i].Contains("/rbt"))
                        rbtmode = true;
                    if (args[i].Contains("/xy"))
                        sizereturnmode = true;
                    if (args[i].Contains("/clear"))
                        clearmode = true;
                    if (args[i].Contains("/rotated"))
                        rotated = true;
                    if (args[i].Contains("/rrotated")) {
                        rotated = false;
                        rrotated = true;
                    }
                    if (args[i].Contains("/center"))
                        center = true;
                    if (args[i].Contains("/o="))
                        outputfilename = args[i].Substring(3);
                    if (args[i].Contains("/i="))
                        inputfilename = args[i].Substring(3);
                    if (args[i].Contains("/s="))
                        stampfilenames = args[i].Substring(3).Split(',');
                    if (args[i].Contains("/sx="))
                        sxpoints = args[i].Substring(4).Split(',');
                    if (args[i].Contains("/sy="))
                        sypoints = args[i].Substring(4).Split(',');
                    if (args[i].Contains("/t=")) {
                        System.Reflection.Assembly mya = System.Reflection.Assembly.GetEntryAssembly();
                        //string textpara = System.IO.Path.GetDirectoryName(mya.Location)+@"\textpara.txt";
                        //StreamWriter sw = new StreamWriter(textpara);
                        byte[] ba = Encoding.Unicode.GetBytes(args[i].Substring(3));
                        MemoryStream ms = new MemoryStream(ba);
                            //sw.Write(args[i].Substring(3));
                            //sw.Close();
                            //sw.Dispose();
                            tfp = new Microsoft.VisualBasic.FileIO.TextFieldParser(ms,System.Text.Encoding.Unicode);
                            tfp.Delimiters = new string[] { "," };
                            tfp.TrimWhiteSpace = false;
                            texts = tfp.ReadFields();
                            tfp.Close();
                            tfp.Dispose();
                            ms.Dispose();
                            //File.Delete(textpara);
                        //texts = args[i].Substring(3).Split(',');
                    }
                    if (args[i].Contains("/tx="))
                        txpoints = args[i].Substring(4).Split(',');
                    if (args[i].Contains("/ty="))
                        typoints = args[i].Substring(4).Split(',');
                    if (args[i].Contains("/fn="))
                        fontname = args[i].Substring(4);
                    if (args[i].Contains("/fs="))
                        fontsizes = args[i].Substring(4).Split(',');
                    if (args[i].Contains("/tr="))
                        trans = args[i].Substring(4);
                    if (args[i].Contains("/op="))
                        opacity = args[i].Substring(4);
                    if (args[i].Contains("/rgb="))
                        rgbs = args[i].Substring(5).Split(',');
                    if (args[i].Contains("/brgb=")) {
                        brgbmode = true;
                        brgbs = args[i].Substring(6).Split(',');
                    }
                    if (args[i].Contains("/sc="))
                        fscale = float.Parse(args[i].Substring(4));
                    if (args[i].Contains("/width="))
                        fwidth = float.Parse(args[i].Substring(7));
                }

                copyneeded = false;
                if (outputfilename.Length == 0) {
                    copyneeded = true;
                    outputfilename = inputfilename + ".pdf";
                }

                if (trans.Length == 0) {
                    ftrans = 0.7F;
                } else {
                    ftrans = float.Parse(trans);
                }
                if (opacity.Length > 0) {
                    fopacity = float.Parse(opacity);
                }
                PdfContentByte over;
                PdfContentByte under;

                PdfReader reader = new PdfReader(inputfilename);
                if (sizereturnmode) {
                    Rectangle rectforsize = reader.GetPageSizeWithRotation(1);
                    reader.Close();

                    Console.WriteLine((rectforsize.Right - rectforsize.Left).ToString() + ":" + (rectforsize.Top - rectforsize.Bottom).ToString());
                    return 0;

                }
                dpimode = false;
                if (fscale == 1.0f)
                    dpimode = true;

                using (FileStream fst = new FileStream(outputfilename, FileMode.Create)) {
                    using (PdfStamper stamper = new PdfStamper(reader, fst)) {
                        if (allpagemode)
                            lastpage = reader.NumberOfPages;
                        else
                            lastpage = 1;

                        for (int currentpage = 1; currentpage <= lastpage; currentpage++) {
                            over = stamper.GetOverContent(currentpage);
                            under = stamper.GetOverContent(currentpage);
                            Rectangle rect = reader.GetPageSizeWithRotation(currentpage);
                            Rectangle mb = reader.GetPageSize(currentpage);

                            float xori = rect.Left;
                            float yori = rect.Top;
                            float yshift = rect.Top;
                            float xshift = rect.Right;

                            if (rotated) {
                                xori = 0;
                                yori = xshift;   //-90度回転している場合は、Y軸の原点を修正する
                                under.ConcatCTM(0, -1f, 1f, 0, 0, yshift);  //-90 degree rotation,underにCTMするとoverにも作用する。
                            }

                            if (rrotated) {
                                yori = 0;
                                xori = yshift;   //時計回りに90回転している場合は、Y軸の原点を修正する
                                under.ConcatCTM(0.0f, 1f, -1f, 0f, 0, -yshift);  //90 degree rotation
                            }

                            if (stampfilenames != null) {
                                //Set Opacity
                                PdfGState gs = new PdfGState();
                                gs.FillOpacity = ftrans;

                                under.SetGState(gs);

                                if (stampfilenames.Length >= sxpoints.Length)
                                    minlen = sxpoints.Length;
                                else
                                    minlen = stampfilenames.Length;
                                //Paste Stamp


                                for (i = 0; i < minlen; i++) {
                                    if (stampfilenames[i].Length > 0) {
                                        Image img = Image.GetInstance(stampfilenames[i]);
                                        
                                        if(img.DpiX != 0 && dpimode)
                                            fscale = 72.0f / (float)(img.DpiX); //DPI補正
                                        img.ScalePercent(fscale * 100);
                                        if (rbmode == false) {
                                            img.SetAbsolutePosition(xori + float.Parse(sxpoints[i]), yori - float.Parse(sypoints[i]) - img.ScaledHeight);
                                        } else {
                                            img.SetAbsolutePosition(rect.Right - float.Parse(sxpoints[i]), rect.Bottom + float.Parse(sypoints[i]) - img.ScaledHeight);
                                        }
                                        under.AddImage(img);
                                    }
                                }
                            }
                            if (clearmode) {
                                minlen = sxpoints.Length;

                                //Paste Stamp
                                for (i = 0; i < minlen; i++) {
                                    under.SetRGBColorFill(255, 255, 255);

                                    under.Rectangle(xori + (float.Parse(sxpoints[i])), yori - float.Parse(sypoints[i]) - float.Parse(typoints[i]), float.Parse(txpoints[i]), float.Parse(typoints[i]));
                                    under.Fill();
                                }
                            }

                            if (texts != null) {
                                //Set Font
                                BaseFont bf = BaseFont.CreateFont(@"c:\windows\fonts\" + fontname + ",0", BaseFont.IDENTITY_H, BaseFont.NOT_EMBEDDED);


                                //over.SetColorStroke(new BaseColor(0xff, 0xff, 0));

                                // スタンプの不透明度
                                if (opacity.Length > 0) {
                                    PdfGState gs1 = new PdfGState();
                                    gs1.FillOpacity = fopacity;
                                    over.SetGState(gs1);
                                    over.SaveState();
                                }

                                if (brgbmode) {
                                    if (texts.Length >= txpoints.Length)
                                        minlen = txpoints.Length;
                                    else
                                        minlen = texts.Length;
                                    float asc;
                                    float des;
                                    float mag;

                                    for (i = 0; i < minlen; i++) {
                                        if (texts[i].Length > 0) {
                                            if (i > fontsizes.Length - 1) {
                                                fontsize = fontsizes[0];
                                            } else {
                                                fontsize = fontsizes[i];
                                            }
                                            over.SetFontAndSize(bf, float.Parse(fontsize));
                                            if (texts[i].Length > (int)fwidth && center) {
                                                mag = fwidth / (float)texts[i].Length;
                                            } else {
                                                mag = 1;
                                            }
                                            asc = bf.GetAscentPoint(texts[i], float.Parse(fontsize) * mag);
                                            des = bf.GetDescentPoint(texts[i], float.Parse(fontsize) * mag);
                                            if (i > (rgbs.Length / 3) - 1) {
                                                over.SetColorFill(new BaseColor(Int32.Parse(rgbs[0]), Int32.Parse(rgbs[1]), Int32.Parse(rgbs[2]))); // R,G,B

                                            } else {
                                                over.SetColorFill(new BaseColor(Int32.Parse(rgbs[i * 3 + 0]), Int32.Parse(rgbs[i * 3 + 1]), Int32.Parse(rgbs[i * 3 + 2]))); // R,G,B
                                            }
                                            over.SetFontAndSize(bf, float.Parse(fontsize) * mag);

                                            Font font = new Font(bf, float.Parse(fontsize));
                                            // フォントカラーを設定
                                            if (i > (rgbs.Length / 3) - 1) {
                                                font.SetColor(Int32.Parse(rgbs[0]), Int32.Parse(rgbs[1]), Int32.Parse(rgbs[2])); // R,G,B
                                            } else {
                                                font.SetColor(Int32.Parse(rgbs[i * 3 + 0]), Int32.Parse(rgbs[i * 3 + 1]), Int32.Parse(rgbs[i * 3 + 2])); // R,G,B
                                            }
                                            Chunk chk = new Chunk(texts[i], font);

                                            //背景色を設定
                                            if (i > (brgbs.Length / 3) - 1) {
                                                if (string.IsNullOrEmpty(brgbs[0]) == false && string.IsNullOrEmpty(brgbs[1]) == false && string.IsNullOrEmpty(brgbs[2]) == false) {
                                                    chk.SetBackground(new BaseColor(Int32.Parse(brgbs[0]), Int32.Parse(brgbs[1]), Int32.Parse(brgbs[2]))); // R,G,B
                                                }
                                            } else {
                                                if (string.IsNullOrEmpty(brgbs[i * 3 + 0]) == false && string.IsNullOrEmpty(brgbs[i * 3 + 1]) == false && string.IsNullOrEmpty(brgbs[i * 3 + 2]) == false) {
                                                    chk.SetBackground(new BaseColor(Int32.Parse(brgbs[i * 3 + 0]), Int32.Parse(brgbs[i * 3 + 1]), Int32.Parse(brgbs[i * 3 + 2]))); // R,G,B
                                                }
                                            }
                                            Phrase phr = new Phrase(chk);

                                            if (center) {
                                                asc = asc / 2;
                                                ColumnText.ShowTextAligned(over, Element.ALIGN_CENTER, phr, xori + float.Parse(txpoints[i]), (yori - float.Parse(typoints[i]) - asc), 0);
                                            } else {
                                                if (rbtmode) {
                                                    ColumnText.ShowTextAligned(over, Element.ALIGN_LEFT, phr, rect.Right - bf.GetWidthPoint(texts[i], float.Parse(fontsize)) - float.Parse(txpoints[i]), (rect.Bottom + float.Parse(typoints[i]) + Math.Abs(des)), 0);
                                                } else {
                                                    ColumnText.ShowTextAligned(over, Element.ALIGN_LEFT, phr, xori + float.Parse(txpoints[i]), (yori - float.Parse(typoints[i]) - asc), 0);
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    //Insert Text
                                    over.BeginText();
                                    if (texts.Length >= txpoints.Length)
                                        minlen = txpoints.Length;
                                    else
                                        minlen = texts.Length;
                                    float asc;
                                    float des;
                                    float mag;

                                    for (i = 0; i < minlen; i++) {
                                        if (texts[i].Length > 0) {
                                            if (i > fontsizes.Length - 1) {
                                                fontsize = fontsizes[0];
                                            } else {
                                                fontsize = fontsizes[i];
                                            }
                                            over.SetFontAndSize(bf, float.Parse(fontsize));
                                            if (texts[i].Length > (int)fwidth && center) {
                                                mag = fwidth / (float)texts[i].Length;
                                            } else {
                                                mag = 1;
                                            }
                                            asc = bf.GetAscentPoint(texts[i], float.Parse(fontsize) * mag);
                                            des = bf.GetDescentPoint(texts[i], float.Parse(fontsize) * mag);
                                            if (i > (rgbs.Length / 3) - 1) {
                                                over.SetColorFill(new BaseColor(Int32.Parse(rgbs[0]), Int32.Parse(rgbs[1]), Int32.Parse(rgbs[2]))); // R,G,B

                                            } else {
                                                over.SetColorFill(new BaseColor(Int32.Parse(rgbs[i * 3 + 0]), Int32.Parse(rgbs[i * 3 + 1]), Int32.Parse(rgbs[i * 3 + 2]))); // R,G,B
                                            }
                                            over.SetFontAndSize(bf, float.Parse(fontsize) * mag);

                                            if (center) {
                                                asc = asc / 2;
                                                over.ShowTextAligned(Element.ALIGN_CENTER, texts[i], xori + float.Parse(txpoints[i]), (yori - float.Parse(typoints[i]) - asc), 0);
                                            } else {
                                                over.ShowTextAligned(Element.ALIGN_LEFT, texts[i], xori + float.Parse(txpoints[i]), (yori - float.Parse(typoints[i]) - asc), 0);
                                            }

                                        }
                                        //over.ShowTextAligned(Element.ALIGN_LEFT, texts[i], 800, 500, 0);
                                    }
                                    over.EndText();
                                }
                            }
                        }
                        stamper.Close();
                        stamper.Dispose();
                        reader.Close();

                    }
                }

                if (copyneeded) { // Copy temporary output to input
                    File.Copy(outputfilename, inputfilename, true);
                    File.Delete(outputfilename);
                }
                return 0;

            } catch (Exception e) {
                Console.WriteLine(e.Message);
                return errorarea;

            }

        }
    }
}



